//
// C++ Implementation: BinaryMLP
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "BinaryMLP.h"
BinaryMLP::BinaryMLP( )
{
    model_name = "BinaryMLP";
    output_number = 1;
    treshold = 0.5;
}

void BinaryMLP::Configure( Parameters & p )
{
//   params = p;
   ((BinaryNetwork*)this)->Configure(p);
}

void BinaryMLP::Learn( Data * d )
{
	Run(d);
//     int inputs = d->GetNumberOfFeatures();
//     int outputs = 1;
//     
//     int hidden = params.hidden_neurons_count;
//     ConnectWithData( d );
//       
//     if (!is_created) CreateNetwork(inputs,outputs,1,&hidden); 
//     SetSlope( params.slope );
//     BestOfNInitiatins( params.number_of_initiatializations );
}

Label BinaryMLP::Test( float * vector )
{
    CalculateActivation( vector );
    return (GetActivation( 0 ) >= treshold)? 1.0 : 0.0 ;
}

void BinaryMLP::Save( char * file )
{
    throw new Exception("Not implemented");
}

void BinaryMLP::Load( char * file )
{
    throw new Exception("Not implemented");
}

void BinaryMLP::Reset( )
{
 //   if (is_created) ((BinaryNetwork *)this)->Reset();
	((Network *)this)->Reset();
	((Network *)this)->Clear();
}

BinaryMLP::~ BinaryMLP( )
{
}

float BinaryMLP::TrainError( )
{
    return t_info.mseError;
}

float BinaryMLP::GetValueOf(char *)
{
	return this->NumberOfNeurons();	
}
