//
// C++ Interface: KSepNetwork
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __KSEPNETWORK_H
#define __KSEPNETWORK_H
//#include "Network.h"
#include "Parameters.h"
#include "BinaryNetwork.h"

class KSepNetwork : public BinaryNetwork
{
private:
    int LearnAndFreez();
    void AddHiddenNode();

protected:
public:
    KSepNetwork();
  //  void Configure(Parameters &p);
    void CreateNetwork(int inputs,int outputs,int hidden = 1 , int *hidden_neurons = NULL);
    Network* DuplicateNetwork();
//    int* GetKseparability(int view=0);
    void Run(Data *data);
    void MyHeuristic(int nr_of_networks=-1);


};



#endif
