//
// C++ Interface: KernelNetwork
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __KERNEL_NETWORK_H
#define __KERNEL_NETWORK_H
#include "KNetwork.h"
#include "Normalization.h"
#include "KernelTransformation.h"
#include "exceptions.h"
#include "Parameters.h"

class KernelNetwork : public Classifier
{
private:
    KNetwork knet;
    Normalization norm;
    KernelTransformation kernelTrans;
        
    int inputFeatures;
public:
   KernelNetwork();
      
    void Configure(Parameters &p);
    void Learn(Data *d);
    Label Test(float *v);
    void Save(char *flie);
    void Load(char *file);
	 float GetValueOf(char *){}
    void Reset();
};


#endif
