#include <iostream>
#include "Parameters.h"
#include <time.h>
#include "test.h"

using namespace std;

int main(int argc,char **argv)
{

    //read config file and parse input arguments 
    Parameters p;
    p.ReadConfigFile("config");
    p.ParseArguments(argc,argv);
    p.DisplayParameters();

   
    
   // cout << argc;
    //prepare clock and log files
    //  ofstream logfile;
    
    //prepare clock
    clock_t tic=clock();
    time_t rawtime;
    time ( &rawtime );
    cout <<  "\nStarting time: " << ctime(&rawtime) << endl;
//     //logfile << "\nStarting time: " << ctime(&rawtime) << endl;

    //set precision of output real numbers
    cout.setf(std::ios_base::fixed);
    cout.precision(3);

/*****************************************************************
*    here we goooooooooooooooo
*******************************************************/
try
{
//  p.train_file="iris_bin.set";
//
//  p.train_file="monks1_bin.set";
 // p.hammingClustering = true;
 // p.d_format = sca;
 // Test1(p);
 // p.initiation = _copy;    PlayGround(p);
 // TestParity(p);
 // SimpleClassification( p );
  
 // SimpleBinaryClassification(p);
 // SimpleMulticlassClassification(p);
    ClassificationTask( p );
 // LearnBoolFunctions(p);
 // LearnBoolFunctions2(p);
 // Test2(p);
 // KenrelTransformationAndCV(p);
 // TestParity2(p);
 // RandomFunctionsTest( p );
/*
  int begin= 1;
  int end = 1;
  
  if (p.networkType==MLP) end = 15;
  for (int i=begin; i <= end; i++)
  {
	  p.initial_nr_of_hidden_neurons = i;
	    BinaryClassificationTask( p );
	}

   */
 // DataCreator(p);
 // PlayGround( p );
}
catch(Exception *e)
{
    e->Info();
}

/*****************************************************************
*    and that's almost everyfing 
*******************************************************/

    //finish the clock
    clock_t toc=clock();
    time ( &rawtime );
    cout <<  "End time: " << ctime(&rawtime);
    float time_elapsed=(toc-tic)
                     /*/CLK_TCK */
                     /(float)CLOCKS_PER_SEC
                     ;
    //   logfile << "End time: " << ctime(&rawtime);
    //    logfile << "\nTime elapsed: " << time_elapsed << " s \t(" 
    //           << time_elapsed/(float)nr_of_functions  << " s. per function)" << endl;
    //    cout << "\nTime elapsed: " << time_elapsed << " s \t(" 
    //         << time_elapsed/(float)nr_of_functions  << " s. per function)" << endl;
    
   // cout << "\nTime elapsed: " << time_elapsed << " s.\n";
 
    //clos all files here
    //    logfile.close();

//     system("pause");

/*****************************************************************
*    the end 
*******************************************************/

   //	Data d;
  //	d.ReadData("iris_norm.dat");

  //	p.train_file="gauss2.dat";

  //	if(p.train_file)
  //		d.ReadData(p.train_file);
  //	else
  //		Error("Podaj zbior treningowy\n");


  //  BinaryNetwork *n = (BinaryNetwork*)(net->DuplicateNetwork());
  //	BinaryNetwork *n = (BinaryNetwork*)net->DuplicateNetwork();


  //	cout << "tworze duplikat\n" << *n;
  //	n->SetNumberOfIterations(5);
  //	n->SetLFactor(0.0);
  //	n->SetPenaltyFactor(0.0);
  //	n->SetLearningRate(0.1);
  //	n->Learning(1);
  //	cout << "Po uczeniu \n" << *n;
  //	SimpleTest st;
  //	st.AddModel(n);
  //	st.Configure(p);
  //	st.Run(&d);
  //	st.DisplayResults();
  //	*n=*net;

  //	BinaryNetwork nn(n);
  //	cout << "po skopiowaniu wag:\n" << nn;
  //	delete n;
  //	delete net;
  //


  //	BinaryData d;
  //	d.CreateParityFunction(4);
  //	d.DisplayData();

  //	KNetwork *kn = new KNetwork();
  //	kn->Configure(p);

  //	kn->Learn(&d);
  //	cout << *kn;

  //	SimpleTest st;
  //	st.AddModel(kn);
  //	st.Run(&d);
  //	st.DisplayResults();

  //	kn->Load("iris.net");
  //	kn->Learn(&d);

  //	SimpleTest st;
  //	st.Configure(p); 
  //	st.AddModel(kn);
  //	st.AddTrainData(&d);
  //	st.Run(&d);
  //	st.DisplayResults();

  //	XTest xt;
  //	xt.Configure(p);
  //	xt.AddModel(&st);
  //	xt.Run(&d);
  //	xt.DisplayResults();

  //	CrossValidation cv;
  //	cv.Configure(p);
  //	cv.AddModel(kn);
  //	cv.Run(&d);
  //	cv.DisplayResults();

  //	XTest xt;
  //	xt.Configure(p);
  //	xt.AddModel(&cv);
  //	xt.Run(&d);
  //	xt.DisplayResults();
  //	cv.Run(&d);
  //	cv.DisplayResults();
  //	BinaryData d;
  //	d.CreateParityFunction(3);
  //	d.DisplayData();

  //cout << *kn;
  //cout << "\n TRENING\n";
  //kn->Learn();


  //	delete kn;
  //	delete net;
  //    BinaryData bdata;
  //    bdata.CreateParityFunction(3);
  //    bdata.DisplayData();

  //    p.max_nr_of_iterations=1000;
  //    p.number_of_initiatializations=10;
  //	p.learning_rate=0.5;
  //	p.lambda_factor=0.5;
  //	p.DisplayParameters();

  //KNetwork *kn = new KNetwork(&bdata);
  //kn->Configure(p);
  //kn->Learn();

  //	Network *s=new Network(&bdata);
  //    s->Configure(p);

  // s->Learning(1);
  //s->BestOfNInitiatins(10);
  //	s->MyHeuristic(10);
  //   s->CalculateNetworkError();
  //   s->PrintError();
  //   s->DisplayMagicNeuronsProjection(1);
  //   delete s;


 
  //    Data *data = new Data();
  //    cout << "Reading file : " << argv[1] << endl;
  /*
   
      BinaryData *data=new BinaryData(77021,4);
      Network *siec = new Network(data);
      siec->CreateNetwork(1);     // tworzy strukture sieci w oparciu o dane
      siec->InitNetwork();        // losowea inicjalizacja wag [-1,1] warstwa wyjsciowa ustawiona na stale (wagi =1)
      //siec->LoadNetwork("test.net");
      siec->SetLearningRate(0.4);
      siec->SetNumberOfIterations(500);
      siec->SetSlope(2);
  //    siec->SetRegularizationFactor(0.0002);
      siec->SetRegularizationFactor(0.0001);
      siec->SetLFactor(0.0);
      siec->SetRewardFactor(0.0);
      siec->SetPenaltyFactor(0.5);
  //    siec->MyHeuristic(5);
      siec->Learning(1);
      //data->DisplayData();
      siec->DisplayWeights();
      siec->DisplayMagicNeuronsProjection();
      siec->PrintError();
   
      delete siec;
      siec=NULL;
   
      delete data;
  */

}
