//
// C++ Interface: test
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#define DEBUG 0
#include <iostream>
#include "KNetwork.h"
#include "Network.h"
#include "Data.h"
#include "BinaryData.h"
#include "Parameters.h"
#include "Model.h"
#include "Tester.h"
#include <time.h>
#include <vector>
#include "BitVector.h"
#include "Results.h"
#include "exceptions.h"
#include "Normalization.h"
#include "KernelTransformation.h"
#include "RandomID.h"
#include "LabelsReprezentation.h"
#include "KernelNetwork.h"
#include "KSepNetwork.h"
#include <string>
#include "BinaryMLP.h"
#include "DataTemperatureReprezentation.h"
#include "BinaryNetworkClassifier.h"
#include "HammingClustering.h"

using namespace std;

void PlayGround(Parameters &p);              //plac zabaw
void Test1(Parameters &p);                   //
void Test2(Parameters &p);                   //not implemented
void Test3( Parameters & p );
//void Test3( Parameters & p );

void TestParity(Parameters &p);
void TestParity2(Parameters &p);
void ClassificationTask(Parameters &p);      //multiclass problems - xtest - cv
void BinaryClassificationTask(Parameters &p);
void LearnBoolFunctions(Parameters &p);
void SimpleClassification(Parameters &p);
void SimpleBinaryClassification(Parameters &p);
void SimpleMulticlassClassification(Parameters &p);
void RandomFunctionsTest(Parameters &p);
void LearnBoolFunctions2(Parameters &p);
void KenrelTransformationAndCV(Parameters &p);
void DataCreator(Parameters &p);
