//
// C++ Interface: NetworkFarm
//
// Description: 
//
//
// Author: Marek Grochowski <grochu@fizyka.umk.pl>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _NETWORKFARM_H
#define _NETWORKFARM_H
#include "Model.h"
#include "Data.h"
#include "exceptions.h"
#include "Network.h"
#include <list>

class NetworkFarm : public Transformation
{
    //Network *netFarm;
    int number_of_networks;
    list<Network> netFarm;

public:
    NetworkFarm():number_of_networks(0)
                {};
    Data* Learn(Data *trainData); 
	 Data* Run(Data *dataToTransform);
    void Configure( Parameters &p);
	 void Reset()	{ };
    ~NetworkFarm();

};


#endif

